<template>
  <body class="pt-3 container-fluid d-flex flex-column align-items-end d-flex flex-row-reverse w-25 bg-transparent">
    <div class="mx-auto mr-0 bg-custom row text-white">
      <div class="trending-topic-list pt-4">
        <h2>Trending Topics</h2>
        <ul class="list-unstyled">
          <li v-for="(topic, index) in trendingTopic.slice(0, visibleTopics)" :key="topic.id" :topic="topic" class="trending-topic-item p-2 fs-5 border-top">
            <p class="fs-6 elemento">{{ index + 1  }}. Tendencias globales</p>
            <TrendingTopic :topic="topic" />
            <p class="fs-6 elemento">Total hashtags: {{  topic.totalPalabra }}</p>
          </li>
          <li>
            <a href="#" @click="cargarMas">Cargar más</a>
          </li>
        </ul>
      </div>
    </div>
  </body>
</template>

<script>
import TrendingTopic from './TrendingTopic.vue';
import axios from 'axios';

export default {
  name: 'TrendingTopicList',
  components: {
    TrendingTopic,
  },
  data() {
    return {
      trendingTopic: [],
      error: null,
      visibleTopics: 5,
    };
  },
  mounted() {
    this.getTrendingTopic();
  },
  methods: {
    getTrendingTopic() {
      axios.get('http://localhost:3001/TT/creaTT')
        .then(response => {
          this.trendingTopic = response.data;
          this.getAndSetTotalPalabra();
        })
        .catch(error => {
          this.error = error.message;
        });
    },
    cargarMas() {
      this.visibleTopics += 3;
    },
    getAndSetTotalPalabra() {
      this.trendingTopic.forEach(topic => {
        axios.get(`http://localhost:3001/h/totalPalabra/${topic.hashTag}`)
          .then(response => {
            topic.totalPalabra = response.data;
          })
          .catch(error => {
            console.error(error);
            topic.totalPalabra = 0;
          });
      });
    },
  },
};
</script>



<style scoped>
.elemento {
  color: #9b9393;
}
.bg-custom {
  background: rgb(56, 52, 52);
  border-radius: 15px;
}
.trending-topic-list {
  

}

.trending-topic-item {
  text-align: right;
 
}
</style>
